import { FirebaseApp } from '@nativescript/firebase-core';
import { IDynamicLink, IDynamicLinkAnalyticsParameters, IDynamicLinkAndroidParameters, IDynamicLinkIOSParameters, IDynamicLinkITunesParameters, IDynamicLinkNavigationParameters, IDynamicLinkParameters, IDynamicLinks, IDynamicLinkSocialParameters, OnLinkListener, ShortLinkType } from './common';
export { ShortLinkType } from './common';
export declare class DynamicLinkAnalyticsParameters implements IDynamicLinkAnalyticsParameters {
    _builder: com.google.firebase.dynamiclinks.DynamicLink.GoogleAnalyticsParameters.Builder;
    _native: com.google.firebase.dynamiclinks.DynamicLink.GoogleAnalyticsParameters;
    constructor();
    static fromNative(link: com.google.firebase.dynamiclinks.DynamicLink.GoogleAnalyticsParameters): DynamicLinkAnalyticsParameters;
    get campaign(): undefined | string;
    set campaign(value: undefined | string);
    get content(): undefined | string;
    set content(value: undefined | string);
    get medium(): undefined | string;
    set medium(value: undefined | string);
    get source(): undefined | string;
    set source(value: undefined | string);
    get term(): undefined | string;
    set term(value: undefined | string);
    get native(): com.google.firebase.dynamiclinks.DynamicLink.GoogleAnalyticsParameters;
    get android(): com.google.firebase.dynamiclinks.DynamicLink.GoogleAnalyticsParameters;
}
export declare class DynamicLinkAndroidParameters implements IDynamicLinkAndroidParameters {
    _builder: com.google.firebase.dynamiclinks.DynamicLink.AndroidParameters.Builder;
    _native: com.google.firebase.dynamiclinks.DynamicLink.AndroidParameters;
    _packageName: string;
    constructor(packageName?: string);
    static fromNative(link: com.google.firebase.dynamiclinks.DynamicLink.AndroidParameters): DynamicLinkAndroidParameters;
    get fallbackUrl(): string;
    set fallbackUrl(value: string);
    get minimumVersion(): number;
    set minimumVersion(value: number);
    get packageName(): string;
    get native(): com.google.firebase.dynamiclinks.DynamicLink.AndroidParameters;
    get android(): com.google.firebase.dynamiclinks.DynamicLink.AndroidParameters;
}
export declare class DynamicLinkIOSParameters implements IDynamicLinkIOSParameters {
    _builder: com.google.firebase.dynamiclinks.DynamicLink.IosParameters.Builder;
    _native: com.google.firebase.dynamiclinks.DynamicLink.IosParameters;
    _bundleId: string;
    constructor(bundleId?: string);
    static fromNative(link: com.google.firebase.dynamiclinks.DynamicLink.IosParameters): DynamicLinkIOSParameters;
    get appStoreId(): string;
    set appStoreId(value: string);
    get bundleId(): string;
    get customScheme(): string;
    set customScheme(value: string);
    _fallbackUrl: string;
    get fallbackUrl(): string;
    set fallbackUrl(value: string);
    get iPadBundleId(): string;
    set iPadBundleId(value: string);
    get iPadFallbackUrl(): string;
    set iPadFallbackUrl(value: string);
    get minimumVersion(): string;
    get native(): com.google.firebase.dynamiclinks.DynamicLink.IosParameters;
    get android(): com.google.firebase.dynamiclinks.DynamicLink.IosParameters;
}
export declare class DynamicLinkITunesParameters implements IDynamicLinkITunesParameters {
    _builder: com.google.firebase.dynamiclinks.DynamicLink.ItunesConnectAnalyticsParameters.Builder;
    _native: com.google.firebase.dynamiclinks.DynamicLink.ItunesConnectAnalyticsParameters;
    constructor();
    static fromNative(link: com.google.firebase.dynamiclinks.DynamicLink.ItunesConnectAnalyticsParameters): DynamicLinkITunesParameters;
    get affiliateToken(): string;
    set affiliateToken(value: string);
    get campaignToken(): string;
    set campaignToken(value: string);
    get providerToken(): string;
    set providerToken(value: string);
    get native(): com.google.firebase.dynamiclinks.DynamicLink.ItunesConnectAnalyticsParameters;
    get android(): com.google.firebase.dynamiclinks.DynamicLink.ItunesConnectAnalyticsParameters;
}
export declare class DynamicLinkNavigationParameters implements IDynamicLinkNavigationParameters {
    _builder: com.google.firebase.dynamiclinks.DynamicLink.NavigationInfoParameters.Builder;
    _native: com.google.firebase.dynamiclinks.DynamicLink.NavigationInfoParameters;
    constructor();
    static fromNative(link: com.google.firebase.dynamiclinks.DynamicLink.NavigationInfoParameters): DynamicLinkNavigationParameters;
    get forcedRedirectEnabled(): boolean;
    set forcedRedirectEnabled(value: boolean);
    get native(): com.google.firebase.dynamiclinks.DynamicLink.NavigationInfoParameters;
    get android(): com.google.firebase.dynamiclinks.DynamicLink.NavigationInfoParameters;
}
export declare class DynamicLinkSocialParameters implements IDynamicLinkSocialParameters {
    _builder: com.google.firebase.dynamiclinks.DynamicLink.SocialMetaTagParameters.Builder;
    _native: com.google.firebase.dynamiclinks.DynamicLink.SocialMetaTagParameters;
    constructor();
    static fromNative(link: com.google.firebase.dynamiclinks.DynamicLink.SocialMetaTagParameters): DynamicLinkSocialParameters;
    get descriptionText(): string;
    set descriptionText(value: string);
    get imageUrl(): string;
    set imageUrl(value: string);
    get title(): string;
    set title(value: string);
    get native(): com.google.firebase.dynamiclinks.DynamicLink.SocialMetaTagParameters;
    get android(): com.google.firebase.dynamiclinks.DynamicLink.SocialMetaTagParameters;
}
export declare class DynamicLinkParameters implements IDynamicLinkParameters {
    _native: com.google.firebase.dynamiclinks.DynamicLink.Builder;
    _shortLinkType: ShortLinkType;
    static fromNative(link: com.google.firebase.dynamiclinks.DynamicLink.Builder, shortLinkType?: any): DynamicLinkParameters;
    analytics: DynamicLinkAnalyticsParameters;
    android: DynamicLinkAndroidParameters;
    domainUriPrefix: string;
    ios: DynamicLinkIOSParameters;
    itunes: DynamicLinkITunesParameters;
    link: string;
    navigation: DynamicLinkNavigationParameters;
    social: DynamicLinkSocialParameters;
    get native(): com.google.firebase.dynamiclinks.DynamicLink.Builder;
    _build(): com.google.firebase.dynamiclinks.DynamicLink.Builder;
}
export declare class DynamicLink implements IDynamicLink {
    _native: com.google.firebase.dynamiclinks.PendingDynamicLinkData;
    static fromNative(link: com.google.firebase.dynamiclinks.PendingDynamicLinkData): DynamicLink;
    get minimumAppVersion(): string;
    get url(): string;
    get utmParameters(): Record<string, string>;
    get native(): com.google.firebase.dynamiclinks.PendingDynamicLinkData;
    get android(): com.google.firebase.dynamiclinks.PendingDynamicLinkData;
    toJSON(): {
        minimumAppVersion: string;
        url: string;
        utmParameters: Record<string, string>;
    };
}
export declare class DynamicLinks implements IDynamicLinks {
    _native: com.google.firebase.dynamiclinks.FirebaseDynamicLinks;
    _app: FirebaseApp;
    static _onLink: OnLinkListener;
    static _didInit: boolean;
    static _callback: org.nativescript.firebase.dynamic_links.FirebaseDynamicLinks.Callback<com.google.firebase.dynamiclinks.PendingDynamicLinkData>;
    constructor();
    buildLink(link: DynamicLinkParameters): Promise<string>;
    createLink(link: string, domainUriPrefix: string): DynamicLinkParameters;
    createShortLink(link: string, domainUriPrefix: string, shortLinkType?: ShortLinkType): DynamicLinkParameters;
    onLink(listener: OnLinkListener): void;
    resolveLink(link: string): Promise<DynamicLink>;
    get native(): com.google.firebase.dynamiclinks.FirebaseDynamicLinks;
    get android(): com.google.firebase.dynamiclinks.FirebaseDynamicLinks;
    get app(): FirebaseApp;
}
